/* GCC */

#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <utility>
#include <queue>
#include <cstring>
#include <set>
#include <stdint.h>
using namespace std;

#ifdef MY_DEBUG
#define NAME "debug"
#else
#define NAME "eight"
#endif

typedef char state[3][3];

state ewin = {{1, 2, 3}, {4, 5, 6}, {7, 8, 0}};
state elose = {{1, 2, 3}, {4, 5, 6}, {8, 7, 0}};
int dt[4][2] = {{1, 0}, {0, 1}, {-1, 0}, {0, -1}};

struct wrap
{
    state a;
};

istream& operator>>(istream &ii, state& s)
{
    for (int i = 0; i < 3; ++i)
        for (int j = 0; j < 3; ++j) {
            int t;
            ii >> t;
            s[i][j] = t;
        }

    return ii;
}

void find_zero(int& x, int& y, state& s)
{
    for (int i = 0; i < 3; ++i)
        for (int j= 0; j < 3; ++j)
        {
            if (s[i][j] == 0)
            {
                x = j;
                y = i;
                return;
            }
        }
}

int64_t hash(state& s)
{
    int64_t h = 0;
    for (int i = 0; i < 3; ++i)
    {
        for (int j = 0; j < 3; ++j)
            h = h*10 + s[i][j];
    }
    return h;
}

set<int64_t> used;

int bfs(state& start)
{
    queue<pair<wrap, int> > q;
    wrap t;
    memcpy(t.a, start, 9);
    q.push(make_pair(t, 0));

    while (true)
    {
        int len = q.front().second;
        state s;
        memcpy(s, q.front().first.a, 9);
        q.pop();
        if (!memcmp(s, ewin, 9))
            return len;
        if (!memcmp(s, elose, 9))
            return -1;
        int x = -1, y = -1;
        find_zero(x, y, s);

        for (int i = 0; i < 4; ++i)
        {
            int nx = x + dt[i][0];
            int ny = y + dt[i][1];

            if (0 <= nx && nx < 3 &&
                0 <= ny && ny < 3)
            {
                wrap t;
                memcpy(t.a, s, 9);
                swap(t.a[y][x], t.a[ny][nx]);
                int64_t hs = hash(t.a);
                if (used.find(hs) == used.end()) {
                    q.push(make_pair(t, len+1));
                    used.insert(hs);
                }
            }
        }
    }
}

int main()
{
    freopen(NAME ".in", "r", stdin);
    freopen(NAME ".out", "w", stdout);
    state start = {};
    cin >> start;

    int ans = bfs(start);
    cout << ans << endl;
    return 0;
}
