/* GCC */

#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <string>
#include <utility>
using namespace std;

#define NAME "ttt"

const int Empty = 0, Cross = 1, Zero = 2;

int m[3][3] = {};

bool check_diags(int sym)
{
    bool win = true;
    for (int i = 0; i < 3; ++i)
        if (m[i][i] != sym)
            win = false;
    if (win)
        return win;
    win = true;
    for (int i = 0; i< 3; ++i)
        if (m[i][2-i] != sym)
            win = false;
    return win;
}

bool check_lines(int sym)
{
    bool w1, w2, w3;
    w1 = w2= w3 = true;
    for (int i = 0; i < 3; ++i)
    {
        if (m[i][0] != sym)
            w1 = false;
        if (m[i][1] != sym)
            w2 = false;
        if (m[i][2] != sym)
            w3 = false;
    }
    if (w1 || w2 || w3)
        return true;
    w1 = w2 =w3 = true;
    for (int i = 0; i < 3; ++i)
    {
        if (m[0][i] != sym)
            w1 = false;
        if (m[1][i] != sym)
            w2 = false;
        if (m[2][i] != sym)
            w3 = false;
    }
    return w1 || w2 || w3;
}

bool is_full()
{
    bool full = true;

    for (int i = 0; i < 3; ++i)
        for (int j = 0; j < 3; ++j)
            if (m[i][j] == Empty)
                full = false;

    return full;
}

int main()
{
    freopen(NAME ".in", "r", stdin);
    freopen(NAME ".out", "w", stdout);

    for (int i = 0; i < 3; ++i)
    {
        for (int j = 0; j < 3; ++j)
        {
            char c;
            scanf("%c", &c);
            switch (c)
            {
            case '.':
                m[i][j] = Empty;
                break;
            case 'x':
                m[i][j] = Cross;
                break;
            case 'o':
                m[i][j] = Zero;
                break;
            default:
                break;
            }

        }
        scanf("\n");
    }
    if (check_diags(Cross) || check_lines(Cross))
        printf("x\n");
    else if (check_diags(Zero) || check_lines(Zero))
        printf("o\n");
    else if (is_full())
        printf("=\n");
    else
        printf(".\n");

    return 0;
}
